/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/include/usr/ipmi/ipmichassiscontrol.H $                   */
/*                                                                        */
/* OpenPOWER HostBoot Project                                             */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2015,2016                        */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

#ifndef __IPMICHASSISCONTROL_H
#define __IPMICHASSISCONTROL_H
/**
 *  @file ipmichassiscontrol.H
 *
 *  IPMI send chassis control command
 *
 */

/******************************************************************************/
// Includes
/******************************************************************************/
#include <stdint.h>
#include <errl/errlentry.H>

namespace IPMI
{

/******************************************************************************/
// Enumerations
/******************************************************************************/

/******************************************************************************/
// Functions
/******************************************************************************/

/**
 * @brief send chassis control command that does poweroff,poweron,powerCycle
 * and reset the system
 *
 * @param[in] chassis control state
 * @return error
 */
errlHndl_t chassisControl(const uint8_t i_chassisControlState);


} // namespace

#endif
